package firework;
import firework.typy.TypPrvok;
import java.awt.*;
import java.util.ArrayList;
import java.util.Arrays;

public enum Farba {
    CERVENA(new TypPrvok[]{TypPrvok.LITHIUM},Color.RED),
    CERVENA2(new TypPrvok[]{TypPrvok.STRONCIUM},Color.RED),
    ORANZOVA(new TypPrvok[]{TypPrvok.VAPNIK},Color.ORANGE),
    ZLATA(new TypPrvok[]{TypPrvok.ZELEZO,TypPrvok.UHLIK},Color.YELLOW),//TODO Doriesit zlatu farbu
    ZLTA(new TypPrvok[]{TypPrvok.SODIK},Color.YELLOW),
    BIELA(new TypPrvok[]{TypPrvok.HORCIK},Color.WHITE),
    STRIEBORNA(new TypPrvok[]{TypPrvok.HLINIK},Color.YELLOW),//TODO Doriesit Striebornu Farbu
    ZELENA(new TypPrvok[]{TypPrvok.BARYUM},Color.GREEN),
    MODRA(new TypPrvok[]{TypPrvok.MED},Color.BLUE);
    
    
    public Color hodnota;
    public TypPrvok[] prvky;
    
    private Farba(TypPrvok[] prvky,Color hodnota){
        this.hodnota=hodnota;
        this.prvky=prvky;
    }
    /**
     * Podla zadanych prvkov zisti farby |
     * Pozor! pocas metody sa prvky z ArrayList-u vymazuju |
     * Pozor 2! ak je viac prvkov tvoriacu rovnaku farbu farba bude vo vratenom ArrayList-e 2-krat
     * (napr. ArrayList Prvkov bude obsahovat 2xSodik vratena bude 2xZlta
     * @param prvky Poskytnute prvky
     * @return zisteneFarby
     */
    public static ArrayList<Color> zistiFarby(ArrayList<TypPrvok> prvky){
        ArrayList<Color> vysledok=new ArrayList<>();
        for (Farba farba:Farba.values()){
            while(prvky.containsAll(new ArrayList<>(Arrays.asList(farba.prvky)))){
                vysledok.add(farba.hodnota);
                //Mazanie Prvkov
                for (TypPrvok p:farba.prvky){
                    prvky.remove(p);
                }
            }
        }
      return vysledok;
    }
}
