
package firework;

import firework.panely.MenuPanel;
import firework.panely.Panel;
import firework.panely.ScenePanel;
import javax.swing.JFrame;
import static javax.swing.JFrame.EXIT_ON_CLOSE;


public class FireworkFrame extends JFrame{
    
    MenuPanel mp;
    ScenePanel sp;
    
    Panel actual;
    
    public FireworkFrame(){
        super("FIREWORK");
        mp=new MenuPanel(this);
        sp=new ScenePanel(mp,this);
        sp.setVisible(false);
        mp.setVisible(false);
        add(sp);
        actual=mp;
        actual.setVisible(true);
        add(mp);
        mp.setFocusable(true);
        sp.setFocusable(true);
        this.setVisible(true);
        this.setDefaultCloseOperation(EXIT_ON_CLOSE);        
        pack();
    }
    
    public void switchPanels(){
        mp.setVisible(false);
        sp.setVisible(false);
        if (actual==mp){
            actual=sp;
            sp.changed();
        }else{
            actual=mp;
        }
        add(actual);
        actual.setVisible(true);
    }
    
    
}
