package firework.komponenty;

import firework.MouseInterface;
import firework.Refreshable;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import firework.itemy.Item;
import firework.panely.Panel.Mouse;

public abstract class Komponent implements MouseInterface {
    
    public int x,y;
    public int width,height;
    
    Mouse m;
    Refreshable r;
    
    public Komponent(int x,int y,int width,int height,Mouse m,Refreshable r){
        this.x=x;
        this.y=y;
        this.width=width;
        this.height=height;
        this.m=m;
        this.r=r;
    }
    
    public abstract void vykresliSa(Graphics g);
        
    
   
    /**
     * Testuje ci sa dany bod nachadza v Komponente
     * @param x X suradnica bodu
     * @param y Y suradnica bode
     * @return "true" ak sa bod nachadza vo vnutri, inak false
     */
    public boolean jeVnutri(int x,int y){
        boolean horizontal=this.x<x&&x<this.x+width;
        boolean vertical=this.y<y&&y<this.y+height;
        return vertical&&horizontal;
    }
    
   
    
}
