package firework.obaly;

import firework.itemy.Gulicka;
import firework.itemy.Item;
import firework.itemy.Obal;
import java.awt.Color;
import java.awt.Graphics;
import java.awt.image.BufferedImage;
import firework.itemy.Obal.*;


public class Gula implements ObalInterface{



    
    
    
    
    
    
    @Override
    public void itemReleased(Item i, Obal o, int x, int y) {
        GulaObject go=new GulaObject(o);       
        if (i instanceof Gulicka){
          if (jeVKruhu(x,y,GulaObject.stredKruhuX,GulaObject.stredKruhuY,GulaObject.maxCelyKruh)){
              if (!jeVKruhu(x, y, GulaObject.stredKruhuX, GulaObject.stredKruhuY, go.velkostVybusninaKruh)){
                  o.gulicky.add(new Obal.GulickaNaVybuchnutie(
                          zistiUhol(GulaObject.stredKruhuX,GulaObject.stredKruhuY,x,y)
                          ,x,y,(Gulicka)i));
              }
          }
       }
        go.vratObal();
    }

 
    
    @Override
    public void mouseDragged(int basex,int basey,int lastx, int lasty, int actualx, int actualy, Obal o) {
        GulaObject go=new GulaObject(o);
        if (jeVStvorci(lastx,lasty,Math.round(go.timerX),GulaObject.timerY,go.timerWidth,GulaObject.timerHeight)){
          int difference=actualx-lastx;
          go.updateTimerWidth(difference, lastx>143);
       } else
               if (jeVKruhu(basex, basey, GulaObject.stredKruhuX, GulaObject.stredKruhuY, GulaObject.maxVybusninaKruh)){
            go.velkostVybusninaKruh+=(
                  vzdialenost(GulaObject.stredKruhuX,GulaObject.stredKruhuY,actualx,actualy)-
                  vzdialenost(GulaObject.stredKruhuX,GulaObject.stredKruhuY,lastx,lasty));
      }else if (jeVStvorci(lastx, lasty, GulaObject.vybusninaX,go.vybusninaY,GulaObject.vybusninaWidth,go.vybusninaHeight)){
          go.vybusninaHeight+=lasty-actualy;
      }
        go.vratObal();
        lastx=actualx;
        lasty=actualy;
    }
 
    @Override
    public BufferedImage vykresliMa(Obal o) {
      GulaObject go=new GulaObject(o);
      BufferedImage obrazok=new BufferedImage(o.workshop.getWidth(),o.workshop.getHeight(),BufferedImage.TYPE_4BYTE_ABGR);
      Graphics g=obrazok.getGraphics();
      g.drawImage(o.workshop, 0, 0, null);
      g.setColor(Color.GRAY);
      g.fillRoundRect(GulaObject.stredKruhuX-Math.round(go.velkostVybusninaKruh),GulaObject.stredKruhuY-Math.round(go.velkostVybusninaKruh), 
              Math.round(go.velkostVybusninaKruh*2), Math.round(go.velkostVybusninaKruh*2), 500, 500);
      g.fillRect(GulaObject.vybusninaX, go.vybusninaY, Math.round(GulaObject.vybusninaWidth), Math.round(go.vybusninaHeight));
      g.setColor(Color.GREEN);//TODO Namiesat tmavu zelenu
      g.fillRect(Math.round(go.timerX),GulaObject.timerY,Math.round(go.timerWidth),GulaObject.timerHeight);
      for (GulickaNaVybuchnutie gnv:o.gulicky){
          BufferedImage image=gnv.g.getWorkImage();
          g.drawImage(image,gnv.x, gnv.y, GulaObject.gulickaDiameter,GulaObject.gulickaDiameter,null);
      }
      return obrazok;
    }
    
    
    private static class GulaObject{
        final static int gulickaDiameter=20;
        
        final static int stredKruhuX=148;
        final static int stredKruhuY=143;
        final static int maxVybusninaY=283;
        final static int minVybusninaY=349;
        final static int vybusninaMaxHeight=minVybusninaY-maxVybusninaY;
        final static int maxVybusninaKruh=66;
        final static int maxCelyKruh=135;
        final static int vybusninaX=48;
        final static int vybusninaWidth=250-48;
        final static float minValue=0.20F;
        
        final static int timerY=143;
        final static int timerHeight=298-timerY;
        final static int timerStred=148;
        final static int timerMaxWidth=50;
                
        float timerX;
        float timerWidth;
        
        
        float velkostVybusninaKruh;
        int  vybusninaY;
        float vybusninaHeight;
        Obal o;
        
        public GulaObject(Obal o){
            velkostVybusninaKruh=Math.round(o.PusnyPrach2*maxVybusninaKruh);
            this.vybusninaHeight=Math.round((minVybusninaY-maxVybusninaY)*o.PusnyPrach1);
            this.vybusninaY=Math.round(minVybusninaY-vybusninaHeight);
            this.timerWidth=o.timer*timerMaxWidth;
            this.timerX=timerStred-timerWidth/2;
            this.o=o;
        }
        
        public Obal vratObal(){
            o.PusnyPrach1=vybusninaHeight/(float)vybusninaMaxHeight;
            if (o.PusnyPrach1>1){
                o.PusnyPrach1=1;
            }
            if (o.PusnyPrach1<minValue){
                o.PusnyPrach1=minValue;
            }
            o.PusnyPrach2=velkostVybusninaKruh/(float)maxVybusninaKruh;
            if (o.PusnyPrach2>1){
                o.PusnyPrach2=1;
            }
            if (o.PusnyPrach2<minValue){
                o.PusnyPrach2=minValue;
            }
            o.timer=timerWidth/(float)timerMaxWidth;
            if (o.timer>1){
                o.timer=1;
            }
            if (o.timer<minValue){
                o.timer=minValue;
            }
            return o;//Zbytocne kedze Obal je referencny datovy typ, ale co uz....
        }
        
        public void updateTimerWidth(int difference,boolean right){
            if (right){
                timerWidth+=difference*2;
                timerX-=difference;
            }else{
                timerWidth-=difference*2;
                timerX+=difference;
            }
        }
    
    
    }
 
    
    
    private static float vzdialenost(int x1,int y1,int x2,int y2){
        int xlength=x1-x2;
        int ylength=y1-y2;
        return Math.round(Math.sqrt(Math.pow(xlength,2)+Math.pow(ylength, 2)));
    }
    
    private static boolean jeVKruhu(int x,int y,int stredX,int stredY,float velkost){
        return (vzdialenost(x,y,stredX,stredY)<=velkost);
    }
    
    private static boolean jeVStvorci(int x,int y,int stvorecX,int stvorecY,float stvorecWidth,float stvorecHeight){
        boolean horizontal=stvorecX<x&&x<stvorecX+stvorecWidth;
        boolean vertical=stvorecY<y&&y<stvorecY+stvorecHeight;
        return vertical&&horizontal;
    }
    /**
     * x1 a y1 by mali byt suradnice stredu gule
     * @param x1
     * @param y1
     * @param x2
     * @param y2
     * @return 
     */
     private static int zistiUhol(int x1,int y1,int x2,int y2){
        float xlength=x2-x1;
        float ylength=y2-y1;
        int angle=(int)Math.toDegrees(Math.atan2(xlength,ylength));
        if (angle<0){
            angle+=360;
        }
        return angle;
      }

    
}
