
package firework.typy;

import java.awt.Color;
import java.awt.image.BufferedImage;
import java.awt.image.Raster;
import java.io.File;
import javax.imageio.ImageIO;


public enum TypPrvok{
    LITHIUM("Li",Color.RED,null),
    STRONCIUM("Sr",Color.RED,null),
    VAPNIK("Ca",Color.ORANGE,null),
    ZELEZO("Fe",Color.YELLOW,null),
    UHLIK("C",Color.YELLOW,null),
    SODIK("Na",Color.YELLOW,null),//TODO IMplement GOLD Color
    HORCIK("Mg",Color.WHITE,null),
    HLINIK("Al",Color.WHITE,null),
    BARYUM("Ba",Color.GREEN,null),
    MED("Cu",Color.BLUE,null),
    TITAN("Ti",Color.WHITE,null),
    ZINOK("Zn",Color.WHITE,null);
    
    public Color farba;
    public Efekt efekt;
    public BufferedImage obrazok;
    public String znacka;
    
    private TypPrvok(String znacka,Color farba,Efekt efekt){
        this.farba=farba;
        this.efekt=efekt;
        this.znacka=znacka;
        String zaciatok="/obrazky/prvky/";//zaciatok cesty
        String cesta="";
        try{
        switch (this.name()){
            case "VAPNIK":
                cesta="ca.jpg";
             break;
                
            case "ZELEZO":
                cesta="fe.jpg";
            break;
                
            case "LITHIUM":
                cesta="li.jpg";
                break;
                
            default:
                cesta="default.jpg";
                break;
                
                
                
        }
        this.obrazok=ImageIO.read(TypPrvok.class.getResource(zaciatok+cesta));
        
        
        } 
        catch(Exception e){
             }
    }
    
}
