
package firework.komponenty;

import firework.Refreshable;
import firework.itemy.Box;
import firework.itemy.Box.LaunchButton;
import firework.itemy.Box.Launcher;
import firework.itemy.Obal;
import firework.panely.ScenePanel;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.util.ArrayList;


public class BoxControl extends Komponent {
    
    public final static int Buttonwidth=50;
    public final static int Buttonheight=50;
    public final static int TextFieldHeight=20;
    private boolean[] odpalene;
    public Box b;
    public ScenePanel sp;

    
    public BoxControl(int x,int y,Box b,Refreshable r,ScenePanel sp){
        super(x,y,Buttonwidth*b.lb.length,TextFieldHeight+Buttonheight,null,r);
        this.b=b;
        this.sp=sp;
        
        
        odpalene=new boolean[b.lb.length];
        int index=0;    
        for (LaunchButton lb:b.lb){
            boolean useful=false; 
            for (Launcher l:lb.launchers){
                if (l.obal!=null){
                    useful=true;
                }
            }
            odpalene[index]=!useful;
            index++;
        }
    }

    @Override
    public void vykresliSa(Graphics g) {
      g.setColor(Color.BLACK);
      g.drawRect(x, y, width, height);
      FontMetrics fm=g.getFontMetrics();
      int textx=x+(width-fm.charsWidth(b.nazov.toCharArray(), 0,b.nazov.length()))/2;
      int texty=y+(TextFieldHeight+fm.getHeight())/2;
      g.drawString(b.nazov, textx, texty);
      int actualx=0;
      int index=0;
      for (LaunchButton lb:b.lb){
          
          if (odpalene[index]){
                g.setColor(Color.GRAY);
            }else{
                g.setColor(Color.WHITE);
            }
            
            g.fillRect(x+actualx,y+TextFieldHeight,Buttonwidth,Buttonheight);
            g.setColor(Color.BLACK);
            g.drawRect(x+actualx,y+TextFieldHeight,Buttonwidth,Buttonheight);          
            index++;
            actualx+=Buttonwidth;
      }
    }

    @Override
    public void mouseMoved(MouseEvent me) {
      //Ignorovane
    }

    
    
    
    @Override
    public void mousePressed(MouseEvent me) {
      ArrayList<Obal> obaly=new ArrayList<>();
        if(jeVnutri(me.getX(), me.getY())){            
            if (y+TextFieldHeight<me.getY()&&me.getY()<y+height){
                int actualx=0;
                int index=0;
                boolean najdene=false;
                    for (LaunchButton lb:b.lb){
                        if (me.getX()<actualx+x){                            
                            if (!najdene){
                            odpalene[index-1]=true;
                            najdene=true;
                            }
                            
                        }
                    if (!najdene){
                       index++;
                    }
                       actualx+=Buttonwidth;
                    }
                    for (Launcher l:b.lb[index-1].launchers){ 
                        b.odpalene.add(l.launch(b.x, b.y, sp.gravity, y));
                   }
              }
        }
        b.odpalene.addAll(obaly);
    }

    @Override
    public void mouseReleased(MouseEvent me) {
      //Ignorovane
    }
}
