package firework.komponenty;

import firework.Refreshable;
import firework.panely.Panel;
import firework.panely.Panel.Mouse;
import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.awt.event.MouseEvent;


public class Button extends Komponent {

    final static Color pressedColor=Color.GRAY;
    final static Color normalColor=Color.WHITE;
    final static Color textColor=Color.BLACK;
    final static Color ramcek=Color.BLACK;
    private Color actualColor;
    private int btnnumber;//identifikacne cislo tlacitka s ktorym sa potom vola metoda buttonInput
    private Panel p;
    private String text;
    
    public Button(int x,int y,int width,int height,Mouse m,Refreshable r,Panel p,int btnnumber,String text){
        super(x,y,width,height,m,r);
        actualColor=normalColor;
        this.p=p;
        this.btnnumber=btnnumber;
        this.text=text;
    }
    
    
    @Override
    public void vykresliSa(Graphics g) {
     g.setColor(actualColor);
     g.fillRect(x, y, width, height);
     FontMetrics fm=g.getFontMetrics();
     int texty=y+(height-fm.getHeight())/2;
     int textx=x+(width-fm.charsWidth(text.toCharArray(), 0, text.length()))/2;
     g.setColor(textColor);
     g.drawString(text,textx,texty);
     g.setColor(Color.BLACK);
     g.drawRect(x, y, width, height);
    }

    @Override
    public void mouseMoved(MouseEvent me) {
        if (!jeVnutri(me.getX(), me.getY())){
            actualColor=normalColor;
        }
        r.refresh();
    }

    @Override
    public void mousePressed(MouseEvent me) {
        if (jeVnutri(me.getX(), me.getY())){
        actualColor=pressedColor;
        p.buttonInput(btnnumber);
       }
        r.refresh();
    }

    @Override
    public void mouseReleased(MouseEvent me) {
        if (jeVnutri(me.getX(), me.getY())){
        actualColor=normalColor;
      }
        r.refresh();
    }
    
}
