package firework.panely;

import firework.Refreshable;
import firework.itemy.Item;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.event.*;
import javax.swing.JPanel;

public abstract class Panel extends JPanel implements MouseMotionListener,MouseListener,Refreshable {
    
    final static int width=800;//Sirka a vyska panelov
    final static int height=600;
    
    final static int iconheight=125;//Sirka a vyska VerticalList-ov
    final static int iconwidth=125;
    
    final static int btnheight=50;//vyska tlacidiel
    
    
    
    public final Mouse mouse;
    protected int mousex,mousey;

    
    public Panel(){
        setPreferredSize(new Dimension(width,height));
        this.mouse=new Mouse();
        this.setFocusable(true);
        this.addMouseListener(this);
        this.addMouseMotionListener(this);
    }

    public abstract void buttonInput(int btnnumber);
    
    @Override
    public void mouseDragged(MouseEvent e) {
   //Ignorovane
    }

    @Override
    public abstract void mouseMoved(MouseEvent e);

    @Override
    public void mouseClicked(MouseEvent e) {
    //Ignorovane
    }

    @Override
    public abstract void mousePressed(MouseEvent e);

    @Override
    public abstract void mouseReleased(MouseEvent e);

    @Override
    public void mouseEntered(MouseEvent e) {
      //Ignorovane
    }

    @Override
    public void mouseExited(MouseEvent e) {
       //Ignorovane
    }

    
     /**
     * Na uchovovanie
     */
    public static class Mouse{
        public Item item;
        final static int imagewidth=50;
        final static int imageheight=50;
        
        public void vykresliSa(Graphics g,int x,int y){
                if (item!=null){
                    int width=imagewidth;
                    int height=imageheight;                  
                    g.drawImage(item.ikona, x-width/2, y-height/2,imagewidth,imageheight,null);               
               }
        }
    }
}
